*! v 1.0.0 PR 13Jul1999.
program define pbeval
version 6
gettoken stub 0: 0
syntax using/ [if] [in] , [ Values(numlist) Freq(numlist) With(str) /*
 */ STandardize ]
if "`with'"!="" { /* `with' is a file holding raw data */
	if "`values'`freq'"!="" {
		di in red "invalid `values' `freq', using file `with'"
		exit 198
	}
	preserve
	use `"`with'"', replace
	pbload `stub'
	local values `r(values)'
	local freq `r(freq)'
	restore
}
else {
	if "`values'"=="" {
		di in red "values() or with() required"
		exit 198
	}
}
/*
	Check for requisite variables (powers and betas).
*/
local done 0
local np 0
while !`done' {
	local i=`np'+1
	cap confirm var `stub'p`i'
	if _rc!=0 {
		local done 1
	}
	else {
		local np `i'
		local pwrs `pwrs' `stub'p`np'
		local coef `coef' `stub'b`np'
		if `i'==1 {
			local shift: char `stub'p1[shift]
			if "`shift'"=="" { local shift 0 }
			local scale: char `stub'p1[scale]
			if "`scale'"=="" { local scale 1 }
			local adjust:char `stub'p1[adjust]
		}
	}
}
if `np'==0 {
	di in red "no powers or coefficients found for `stub'"
	exit 2001
}
local stuff `pwrs' `coef'
cap confirm var b0
if _rc==0 {
	local b0 b0
	local stuff `stuff' `b0'
}
/*
	Check integrity of values and freq
*/
local nv: word count `values'
if "`freq'"!="" {
	local nf: word count `freq'
	if `nf'!=`nv' {
		di in red "number of values() and freq() differ"
		exit 198
	}
}
marksample touse
preserve
quietly {
	keep if `touse'
	keep `stuff'
	if "`standar'"!="" {
		tempvar wsum		/* weighted sum of fitted values */
		tempname fsum
		gen double `wsum'=0
		scalar `fsum'=0
	}
	local i 1
	while `i'<=`nv' {
		local v: word `i' of `values'
		if "`freq'"!="" { local f: word `i' of `freq' }
		else local f 1
		gen double `stub'`i'=`v'
		fraceval var `stub'`i' "`pwrs'" "`coef'" "`b0'" /*
		 */ "`adjust'" "`shift'" "`scale'"
		local fp `r(fpvar)'
		if "`standar'"!="" {
			replace `wsum'=`wsum'+`f'*`fp'
			scalar `fsum'=`fsum'+`f'
		}
		replace `stub'`i'=`fp'
		local i=`i'+1
	}
	if "`standar'"!="" {
		replace `wsum'=`wsum'/`fsum'
		local i 1
		while `i'<=`nv' {
			replace `stub'`i'=`stub'`i'-`wsum'
			local i=`i'+1
		}
		drop `wsum'
	}
	drop `stuff' `fp'
	char _dta[pb_v] "`values'"
	char _dta[pb_f] "`freq'"
	char _dta[pb_x] "`stub'"
	save `using', replace
	count
}
di _n in ye `nv' in gr " variables and " in ye r(N) /*
 */ in gr " observations based on " in ye "`stub'" /*
 */ in gr " saved to file " in ye "`using'" in gr "."
end

*! v 1.0.0 Pr 25Jun1999.
program define pbload, rclass
version 6
syntax varlist(min=1 max=1)
quietly {
	keep if `varlist'!=.
	sort `varlist'
	tempvar freq
	by `varlist': gen long `freq'=_N
	by `varlist': drop if _n<_N
	local i 1
	while `i'<=_N {
		local v=`varlist'[`i']
		local values `values' `v'
		local f=`freq'[`i']
		local freqs `freqs' `f'
		local i=`i'+1
	}
	return local values `values'
	return local freq `freqs'
	return scalar uniq=_N
}
end
