*! v 1.0.2 PR 06feb2008
program define fpdiagnostic, rclass sortpreserve
version 8.2
gettoken cmd 0: 0
if "`cmd'"!="stcox" & "`cmd'"!="streg" & "`cmd'"!="stpm" {
	gettoken y 0: 0
	confirm var `y'
	local wt [aweight fweight pweight iweight]
	local is_st 1
}
else {
	local wt
	local is_st 0
}

syntax varlist(min=1 numeric) [if] [in] `wt' using/ [, ADJust(varlist) CASE *]

quietly {
	marksample touse
	markout `touse' `y' `adjust'
	if `is_st' capture replace `touse'=0 if _st==0
	local nvar: word count `varlist' // !! does not take into account that a var may have all missing values
	tempname tmp dev0 dev1 dev2 devlin devnull
	tempvar pattern
	count if `touse'
	local n=r(N)
	if "`case'"!="" {	// drop each case in order
		gen long `pattern'=_n if `touse'
		local ng `n'
		local message `n' cases found
		local pattvarname case
		gsort -`touse' `pattern'
	}
	else {
		egen long `pattern'=group(`varlist') if `touse'
		sum `pattern', meanonly
		local ng=r(max)
		local message `ng' covariate patterns found among `n' observations
		local pattvarname pattern
	}
	noi di as text _n "`message'" _n(2) "Processing... " _cont
	postfile `tmp' `pattvarname' x freq devnull devlin devfp1 devfp2 using `using', replace
	forval j=1/`ng'{
		fracpoly `cmd' `y' `varlist' `adjust' if `touse'==1 & `pattern'!=`j'
		scalar `dev0'=e(fp_d0)
		scalar `dev1'=e(fp_d1)
		scalar `dev2'=e(fp_d2)
		scalar `devlin'=e(fp_dlin)
		if `nvar'==1 {
			sum `varlist' if `touse'==1 & `pattern'==`j'
			post `tmp' (`j') (r(mean)) (r(N)) (`dev0') (`devlin') (`dev1') (`dev2')
		}
		else {
			count if `touse'==1 & `pattern'==`j'
			post `tmp' (`j') (.) (r(N)) (`dev0') (`devlin') (`dev1') (`dev2')
		}
		if mod(`j', 10)==0 noi di `j', _cont
	}
	postclose `tmp'
}
di
return scalar N=`n'
return scalar ng=`ng'
end
