{smcl}
{* 12apr2008}{...}
{hline}
help for {hi:fraceval}{right:Patrick Royston}
{hline}

{title:Evaluate fractional polynomial function}

{phang2}
{cmd:fraceval}
{c -(}{cmd:var} {it:varname}{c )-} | {c -(}{cmd:num} {it:#}|{it:scalarname}{c )-}

{phang2}
{cmd:fraceval}
{c -(}{cmd:var} {it:varname}{c )-} | {c -(}{cmd:num} {it:#}|{it:scalarname}{c )-}
{cmd:"}{it:powers}{cmd:"}
{cmd:"}{it:coeffs}{cmd:"}
[
{it:beta0}
{it:adjust}
{it:shift}
{it:scale}
]

{pstd}
where each item of {it:powers} and of {it:coeffs} is {it:#}, {it:scalarname}
or {it:varname},
{it:beta0} is {it:#}, {it:scalarname}, {it:varname} or {cmd:""}, and
{it:adjust}, {it:shift} and {it:scale} are {it:#}, {it:scalarname} or {cmd:""}.


{title:Description}

{pstd}
{cmd:fraceval} evaluates fractional polynomial function(s) at a variable
{it:varname} or at a number {it:#} or {it:scalarname}.
The result is stored in {cmd:r(fp)} if the {it:#}|{it:scalarname} form is used,
otherwise in a new variable called {cmd:_fp}. The latter is replaced
without warning if it already exists. Note that {it:varname} may
be the original X-variable used by {opt fracpoly} or a different variable
at which evaluation of the function is required. This facilitates 
out-of-sample prediction.

{pstd}
With the first form of the command, parameters from the most recent fit
of {help fracpoly} are used.

{pstd}
With the second form of the command, powers {it:powers} and corresponding
regression coefficients {cmd:coeffs} are used to evaluate the function.
{it:beta0} is an optional
intercept term. {it:powers}, {cmd:coeffs} and {it:beta0} are
allowed to be any combination of varnames, numbers and scalars.
However, if any of them is a varname then the {cmd:num}
{it:#} | {it:scalarname} format is not allowed, since the FP is
evaluated for each value of the variable(s) in question.

{pstd}
{it:adjust}, a {it:#} or {it:scalarname},is used to "adjust" the FP function
such that the function evaluates to zero at this value. {it:shift},
a {it:#} or {it:scalarname}, is added to the argument of the FP function
before evaluation. And {it:scale}, a {it:#} or {it:scalarname}, is divided
into the argument of the FP function before evaluation.


{title:Examples}

{pstd}
First form:

{phang}{cmd:. fracpoly regress mpg weight}{p_end}
{phang}{cmd:. fraceval num 25}{p_end}
{phang}{cmd:. scalar xx = 25}{p_end}
{phang}{cmd:. fraceval num xx}{p_end}
{phang}{cmd:. fraceval var x2}{p_end}

{pstd}
Second form:

{phang}{cmd:. fraceval num 25 "-1 0" "1.25 -2.33" 9.09}{p_end}
{phang}{cmd:. fraceval num 25 "-1 0" "1.25 -2.33" 9.09 "" 1 100}{p_end}
{phang}{cmd:. fraceval var x2 "-1 0" "1.25 -2.33"}{p_end}
{phang}{cmd:. fraceval var x2 "p1 p2" "b1 b2" b0}{p_end}
{phang}{cmd:. fraceval var x2 "0 0" "b1 b2"}{p_end}


{title:Author}

{pstd}
Patrick Royston, MRC Clinical Trials Unit, London.{break}
pr@ctu.mrc.ac.uk


{title:Also see}

{p 4 13 2}
Manual: {bf:[R] fracpoly}
