{smcl}
{* 19mar2008}{...}
{hline}
help for {hi:mfpi}{right:(Patrick Royston)}
{hline}


{title:Modelling interactions between categorical and continuous/categorical covariates}


{title:Syntax}

{phang2}
{cmd:mfpi}
{it:regression_cmd}
[{it:yvar}]
[{it:xvarlist}]
{ifin}
{weight}
{cmd:, with(}{it:withvar}{cmd:)}
[{it:options}]

{phang2}
{cmd:mfpi_plot}
{it:varname}
[{cmd:, }
{it:options}]

{pstd}
{marker syntax}where

{pin}
{it:regression_cmd} may be
{helpb clogit},
{helpb cnreg},
{helpb glm},
{helpb intreg}, 
{helpb logistic},
{helpb logit},
{helpb mlogit},
{helpb nbreg},
{helpb ologit},
{helpb oprobit},
{helpb poisson},
{helpb probit},
{helpb qreg},
{helpb regress},
{helpb stcox},
{helpb streg},
or
{helpb xtgee}.


{synoptset 28 tabbed}{...}
{synopthdr}
{synoptline}
{synopt :{opt adj:ust(varlist)}}adjusts linearly for {it:varlist}{p_end}
{synopt :{opt all}}include out-of-sample observations in generated variables{p_end}
{synopt :{opt det:ail}}gives additional details of the models fitted{p_end}
{synopt :{opt df(dflist)}}sets up the degrees of freedom for each predictor in {it:xvarlist}{p_end}
{synopt :{opt fl:ex(#)}}defines the flexibility of the main-effects and interaction models{p_end}
{synopt :{opt fp1(fp1_varlist)}}use fractional polynomials of degree 1 for main effects and interactions with {it:fp1_varlist}{p_end}
{synopt :{opt fp2(fp2_varlist)}}use fractional polynomials of degree 2 for main effects and interactions with {it:fp2_varlist}{p_end}
{synopt :{opt gend:iff(stubname)}}generates new variable(s) which contain the difference between the estimated functions{p_end}
{synopt :{opt genf(string)}}generates new variables which contain fitted functions{p_end}
{synopt :{opt lin:ear(lin_varlist)}}defines a list of variables ({it:lin_varlist}) whose linear interaction with {it:withvar} is to be investigated{p_end}
{synopt :{opt mfp:opts(options)}}are additional options for {help mfp}{p_end}
{synopt :{opt nose:diff}}suppresses SE and CI for estimates from {opt gendiff()}{p_end}
{synopt :{opt sel:ect(select_list)}} sets the significance levels for variable selection in {it:xvarlist}{p_end}
{synopt :{opt show:model}}shows the variables and FP transformations selected from {it:xvarlist} by {help mfp}{p_end}
{synopt :{opt top:coded}}top-codes the {opt with()} variable, {it:withvar}{p_end}
{synopt :{it:regression_cmd_options}}are options for {it:regression_cmd}{p_end}

{syntab :{it:options} for {cmd:mfpi_plot}}
{synopt :{opt stub:name(string)}}{it:string} as given in the {opt gendiff(string)} option{p_end}
{synopt :{opt vn(#)}}variable number in {opt linear()}, {opt fp1()} or {opt fp2()}{p_end}
{synopt :{opt plot(plot)}}adds other plots to the generated graph{p_end}
{synopt :{it:graph_options}}options for {cmd:graph twoway}{p_end}
{synoptline}
{p2colreset}{...}


{phang}
All weight types supported by {it:regression_cmd} are allowed; see {help weight}.{p_end}

{phang}
{it:yvar} is not allowed for {opt streg} and {opt stcox}.  For these commands,
you must first {helpb stset} your data.


{title:Description}

{pstd}
{cmd:mfpi} is designed for investigating interactions of a categorical covariate
({it:withvar}) with covariate(s) specified by any combination of the options
{cmd:fp1()}, {cmd:fp2()} or {cmd:linear()} (see {it:Remarks} for further details).
Often, {it:withvar} will be the
treatment variable in a randomised controlled trial of one or more treatments
against control.

{pstd}
{cmd:mfpi_plot} produces a treatment-effect plot derived from variables
saved using the {opt gendiff()} option of {cmd:mfpi}.


{title:Options for {cmd:mfpi}}

{phang}
{cmd:with(}{it:withvar}{cmd:)} is not optional and
defines the categorical variable whose interactions with other variables
    are of interest. {it:withvar} must have at least two distinct non-missing values,
    but the codes may be arbitrary since they are mapped to 0, 1, 2, ...
    internally. The category corresponding to the lowest value is taken as the
    reference category (level 0).

{phang}
{cmd:adjust(}{it:varlist}{cmd:)} includes {it:varlist} as linear
term(s) in all models fitted.

{phang}
{cmd:all} allows prediction (see {cmd:genf()}, {cmd:gendiff()} options)
for all available cases, irrespective exclusion by {cmd:if},
{cmd:in} or weights.

{phang}
{cmd:detail} gives additional details of the models fitted.

{phang}
{cmd:df(}{it:df_list}{cmd:)}
    sets up the degrees of freedom (df) for each predictor in {it:xvarlist}.
    The df (not
    counting the regression constant, {cmd:_cons}) are twice the degree of the
    FP, so for example an {it:xvar} fitted as a second-degree FP (FP2) has 4
    df.  The first item in df_list may be either {it:#} or
    {it:varlist}{cmd:}{it:#}.  Subsequent items must be
    {it:varlist}{cmd:}{it:#}.  Items are separated by commas and {it:varlist}
    is specified in the usual way for variables.  With the first type of item,
    the df for all predictors are taken to be {it:#}.  With the second type of
    item, all members of {it:varlist} (which must be a subset of
    {it:xvarlist}) have {it:#} df.

{pin}
    The default degrees of freedom for a predictor of type varlist specified in
    {it:xvarlist} but not in {it:df_list} are assigned according to the
     number of distinct (unique) values of the predictor, as follows:

        {hline 43}
        # of distinct values    default df
        {hline 43}
                  1             (invalid predictor)
                 2-3            1
                 4-5            min(2, {cmd:dfdefault()})
                 >=6            {cmd:dfdefault()}
        {hline 43}

{pin}
    Example:  {cmd:df(4)}{break}
    All variables have 4 df.

{pin}
    Example:  {cmd:df(2, weight displ:4)}{break}
    {cmd:weight} and {cmd:displ} have 4 df, all other variables have 2 df.

{pin}
    Example:  {cmd:df(weight displ:4, mpg:2)}{break}
    {cmd:weight} and {cmd:displ} have 4 df, {cmd:mpg} has 2 df, all other
    variables have the default of 1 df.

{pin}
    Example:  {cmd:df(weight displ:4, 2)}{break}
    All variables have 2 df since the final 2 overrides the earlier 4.

{phang}
{opt flex(#)} determines the flexibility of the main-effects and interaction model.
{it:#} = 1 is the least flexible and {it:#} = 4 is the most, with 2 and 3 intermediate.
See {opt Remarks} for further details.

{phang}
{cmd:fp1(}{it:fp1_varlist}{cmd:)}
defines a list of continuous variables whose
    interactions with {it:withvar} are to be investigated by fitting fractional polynomial
    functions of degree 1 (i.e. FP1) to each member of {it:varlist} in turn,
    at each level of {it:withvar}.

{phang}
{cmd:fp2(}{it:fp2_varlist}{cmd:)}
defines a list of continuous variables whose
    interactions with {it:withvar} are to be investigated by fitting fractional polynomial
    functions of degree 2 (i.e. FP2) to each member of {it:varlist} in turn,
    at each level of {it:withvar}.

{phang}
{cmd:gendiff(}{it:stubname}{cmd:)}
generates new variable(s) called {it:stubname}{it:#}{cmd:_}{it:j} which contains
    fj-f0, the difference between the estimated functions (at level j minus level 0
    of {it:withvar}) for the {it:#}th member
    of the list composed of {it:lin_varlist},
    {it:fp1_varlist}, {it:fp2_varlist}, in that order. The difference fj-f0 is an
    estimate of the covariate-specific effect of level j compared with level 0
    (e.g. a covariate-specific treatment effect). {opt gendiff()} also creates new
    variable(s) called {it:stubname}{it:#}{cmd:s_}{it:j} which contain the standard
    error of fj-f0, and {it:stubname}{it:#}{cmd:lb_}{it:j} and
    {it:stubname}{it:#}{cmd:ub_}{it:j}, the lower and upper 95% confidence limits
    for the treatment effect, thus providing all the quantities necessary for a
    treatment-effect plot.

{phang}
{cmd:genf(}{it:string}{cmd:)}
generates new variables called {it:string}{it:#}{cmd:_0}, {it:string}{it:#}{cmd:_1}, ...
    which contain the fitted functions at levels 0, 1, ... of {it:withvar},
    respectively, for the {it:#}'th member of the list composed of
    {it:lin_varlist},
    {it:fp1_varlist}, {it:fp2_varlist}, in that order. For variables in {it:fp1_varlist}
    and {it:fp2_varlist}, the same FP transformation is used at each level of {it:withvar}.
    The estimated function at level 0 of {it:withvar} is adjusted to have mean zero.

{phang}
{cmd:linear(}{it:lin_varlist}{cmd:)}
defines a list of variables whose linear
    interactions with {it:withvar} are to be investigated. If a categorical variable
    has more than 2 levels, you must create the necessary dummy variables
    yourself and place them between parentheses to indicate that they should be
    tested together. More properly, therefore, {it:lin_varlist} is a list of 
    variables, some of which may be dummies for categorical variables.

{pin}
    Example: {cmd:linear((who2 who3))} would bind {cmd:who2} and {cmd:who3}
    together to create a predictor with 2 degrees of freedom for its main effect.

{phang}
{cmd:mfpopts(}{it:mfp_options}{cmd:)}
are additional options for {help mfp}.

{phang}
{opt nosediff} suppresses SE and CI for estimates from {opt gendiff()}. The default
behaviour is described under {opt gendiff()}.

{phang}
{cmd:select(}{it:select_list}{cmd:)}
    sets the nominal P-values (significance levels) for variable selection among
    {it:xvarlist} by
    backward elimination.  A variable is dropped if its removal causes a
    non-significant increase in deviance.  The rules for {it:select_list} are
    the same as for {it:df_list} in the {cmd:df()} option (see above).  Using
    the default selection level of 1 for all variables forces them all into
    the model.  Setting the nominal P-value to be 1 for a given variable
    forces it into the model, leaving others to be selected or not. The
    nominal P-value for elements of {it:xvarlist} bound by parentheses is specified
    by including {cmd:(}{it:varlist}{cmd:)} in {it:select_list}.

{pin}
    Example:  {cmd:select(0.05)}{break}
    All variables have nominal P-value 5 percent.

{pin}
    Example:  {cmd:select(0.05, weight:1)}
    All variables except {it:weight} have nominal P-value 5 percent,
    {cmd:weight} is forced into the model.

{pin}
    Example:  {cmd:select(a (b c):0.05)}{break}
    All variables except {cmd:a}, {cmd:b}, and {cmd:c} are forced into the
    model.  {cmd:b} and {cmd:c} are tested jointly with 2 df at the 5 percent
    level, and {cmd:a} is tested singly at the 5 percent level.

{phang}
{cmd:showmodel}
shows the variables selected from {it:xvarlist} by {help mfp} and their FP powers, 
where relevant. {cmd:showmodel} is a concise alternative to {cmd:detail}.

{phang}
{opt topcoded} top-codes the {opt with()} variable, that is, the reference
category is the highest value of {it:withvar}. The default is bottom-coding,
that is, the reference category is the lowest value of {it:withvar}.

{phang}
{it:regression_cmd_options}
are options for {it:regression_cmd} (e.g. {cmd:exposure()} for
    {help poisson}).

{title:Options for {cmd:mfpi_plot}}

{phang}
{opt stubname(stubname)} is not optional. {it:stubname} is the string
specified in the {opt gendiff(stubname)} option of {cmd:mfpi}.

{phang}
{opt level(#)} defines the comparison between levels of {it:withvar}
that is required. Levels of {it:withvar} are coded 0, 1, 2, ...,
the reference category being level 0. For example, specifying {opt level(2)}
would give a treatment-effect plot comparing level 2 of {it:withvar}
with level 0. Default {it:#} is 1.

{phang}
{opt vn(#)} identifies the variable in {opt linear()},
{opt fp1()} and {opt fp2()}, in that order, whose associated
treatment effect is to be plotted. Only one variable may be
plotted in a given call to {cmd:mfpi_plot}. For example, if 
{cmd:linear(x1 x2)} {cmd:fp1(x1 x3)} {cmd:fp2(x3)} were specified,
the list of variables is x1 x2 x1 x3 x3 and the total number of variables
is 5 (not 3). Thus {it:#} would be an integer between 1 and 5. Default
{it:#} is 1.

{phang}
{opt plot(plot)} provides a way to add other plots to the 
generated graph; see help {help plot_option:plot option}.

{phang}
{it:graph_options} are options of {cmd:graph twoway}, such as
{cmd:xtitle()}, {cmd:ytitle()}, etc.


{title:Remarks}

{title:Methodology}

{pstd}
The algorithm used in {cmd:mfpi} may be summarised as follows. To fix ideas, it
is assumed that {it:withvar} is a binary treatment indicator variable in a randomised
controlled clinical trial with two parallel groups. {it:withvar} therefore has two
levels, arbitrarily labelled 0 and 1.

{pstd}
We first describe the MFPI algorithm for the default flexibility setting,
{cmd:flex(1)}, i.e. the least flexible case.

{pstd}
Let Z be the continuous or binary covariate of immediate interest and let T be
the binary treatment variable with values 0 and 1. Let X be a vector
of potentially prognostic factors. In {cmd:mfpi}, Z is a member of {it:lin_varlist},
{it:fp1_varlist} or {it:fp2_varlist}, T is {it:withvar} and X is {it:xvarlist}.
The basic idea is to model the
relationship between the outcome and Z at each level of T, adjusting for
selected members of X, the latter variables transformed by FP if appropriate.
A test for interaction is performed on regression coefficients at the
final step. The procedure for a Z in {it:fp2_varlist}
(see {opt fp2(fp2_varlist)} is as follows:

{p 8 12 2}
1.  Apply the MFP algorithm to X with a P-value threshold of a* for selecting
variables and FP transformations. Let X* be the resulting covariate vector,
which we will call the adjustment model. X* may include (transformed) variables
in X selected by the MFP algorithm. If all variables in X are uninfluential, X*
may even be null. No covariate adjustment is then performed.
In some cases, X* may be formulated from subject-matter
knowledge, avoiding data-driven searching.

{p 8 12 2}
2.  Find by maximum likelihood the best-fitting FP2 powers (p1,p2) for Z,
adjusting for X*.

{p 8 12 2}
3.  For groups j = 0, 1 and powers p_i (i = 1, 2), define new predictors
Z_ji = Z^p_i if T = j, Z_ji = 0 otherwise.

{p 8 12 2}
4.  The test of T x Z interaction is a likelihood ratio test between the nested
models T, Z_01, Z_02, Z_11, Z_12, X* and T, Z^p1, Z^p2, X*. The difference
in deviance is compared with chisquare on 2 d.f.

{p 8 12 2}
5.  If an interaction is not found, Z is regarded as a potential prognostic
factor only. To investigate if an FP2 function is still needed for Z,
the final model is chosen by repeating step 1, but including Z as a
potential prognostic factor.

{pstd}
The procedure for a Z in {it:fp1_varlist}, i.e.
using FP1 rather than FP2 functions of Z, is in principle identical.
The interaction is tested on 1 d.f.

{pstd}
If Z is binary or is modelled as linear (i.e. is a member of {it:lin_varlist}),
the approach reduces to the usual procedure to estimate and to
test for an interaction adjusted for covariates X*.

{pstd}
Extension to cases where T has more than 2 levels follows immediately.

{pstd}
For further details of the MFP algorithm used to construct X*, see Royston &
Ambler (1999), Sauerbrei & Royston (1999) and {help mfp}.
Further information on the method and applications is given by
Royston & Sauerbrei (2004).

{title:Other flexibility values}

{pstd}
The covariates X are treated in the same way for all values of {opt flex()}.
Only the main effect of Z and its interaction with T are dealt
with differently, as follows.

{pstd}
With {cmd:flex(2)}, the best-fitting FP powers for Z are found within
the context of interaction models. The powers are constrained to be
the same for all levels of T. The FP powers for the main effect of Z are
taken as the same as for the Z x T interaction.

{pstd}
{cmd:flex(3)} is the same as {cmd:flex(2)} except that the FP powers
for the main effect of Z are determined independently of the interaction,
exactly as for {cmd:flex(1)}.

{pstd}
{cmd:flex(4)}, the most flexible option, calls for FP powers to be 
estimated for the main effect of Z and also for all levels of T
in the interaction context.


{title:Warning}

{pstd}
Excitement engendered by the discovery of interactions should be tempered by a
proper caution. There is a significant problem of multiplicity and of potential
instability of the FP functions found. See Royston & Sauerbrei (2004) for a
more detailed discussion of this issue. It is prudent to check (a) whether the
functions in each treatment group suggest cutpoint(s) that can reproduce a
difference in response, (b) whether the interaction is present in univariate
as well as multivariable models, and (c) whether it is robust to the choice of
adjustment model.


{title:Examples}

{phang}{cmd:. mfpi cox time x1 x2 c1 c2 c3, dead(dead) select(0.05) showmodel}
{cmd:with(treat) linear(c1 (c2 c3)) fp2(x1 x2)}{p_end}

{phang}{cmd:. mfpi logit y x1 x2 c1 c2 c3, select(1) degree(1) dfdefault(2)}
{cmd:with(treat) linear(c1 (c2 c3)) fp1(x1) fp2(x2) genf(f)}
{cmd:gendiff(d) nosediff}{p_end}

{phang}{cmd:. mfpi regress y, with(treat) linear((c2 c3))}{p_end}


{title:Author}

{pstd}
Patrick Royston, Medical Research Council, UK.{break}
patrick.royston@ctu.mrc.ac.uk


{title:References}

{pstd}
P. Royston and W. Sauerbrei. 2008. Multivariable model-building, chapter 7.
Chichester: John Wiley and Sons.

{pstd}
P. Royston and W. Sauerbrei. 2004. A new approach to modelling interactions between treatment
and continuous covariates in clinical trials by using fractional polynomials. Statistics in Medicine
23: 2509-2525.

{pstd}
W. Sauerbrei, P. Royston and K. Zapien. 2007. Detecting an interaction between treatment
and a continuous covariate: a comparison of two approaches.
Computational Statistics and Data Analysis 51: 4054-4063.


{title:Also see}

{p 5 14 2}
Manual:  {hi:[R] fracpoly}, {hi:[R] mfp}
{p_end}
{p 4 14 2}
On-line:  help for {help mfp}
{p_end}
