*! v 1.0.1 PR 03jun2008
/* mvmb_profile.ado

	Called by example do-files for examples from:

	"Multivariable model-building: a pragmatic approach ..." by P. Royston & W. Sauerbrei

	Place this file in your Stata personal ado directory
	(type -sysdir- in Stata to determine where this directory is for your system.)

	Edit the file to  point to the appropriate data directory and the desired log file target directory.

	A local macro `BOOKDIR' defines the home directory for the RS book materials.
	Edit line 24 below to give the correct path name of this directory (the default is c:\rsbook).

	Global macros are defined from `BOOKDIR' to specify

	1) The data directory path where example datasets reside

	2) The directory path specifying where exercise log files and graphs go.
*/
program define mvmb_profile
	version 9.2
	local BOOKDIR "c:\rsbook"             // home directory for RS book materials: edit this line accordingly
	global mvmb_data  "`BOOKDIR'\data\"   // data directory
	global mvmb_log   "`BOOKDIR'\output\" // directory for log files, graphs, etc
	set scheme s1mono
end
