*! v 1.0.0 PR 20Jun2000.
program define pbxtract, rclass
version 6
syntax [if] [in] , CLEAR [Centile(numlist >0 <100) MEan Sd N MAd Dsq /*
 */ TRunc(real 0) Ref(int 1)]
local values: char _dta[pb_v]
local nxval: word count `values'
local stub: char _dta[pb_x]
if "`values'"=="" | "`stub'"=="" {
	di in red "data has invalid characteristics char[_dta]"
	exit 198
}
if `trunc'<0 | `trunc'>=0.5 {
	di in red "invalid trunc()"
	exit 198
}
local f: char _dta[pb_f]
local sumstat=("`centile'`mean'`sd'`n'"!="")
local stabil=("`mad'`dsq'"!="")
if (`sumstat'*`stabil')==1 {
	di in red "incompatible options chosen"
	exit 198
}
if `stabil' {
	if `ref'<1 | `ref'>_N {
		di in red "invalid ref(), must be between 1 and " _N
		exit 198
	}
}
quietly {
	preserve
	marksample touse
	if !`sumstat' & !`stabil' {	/* save fitted values only */
		drop if !`touse'
		drop `touse'
		xpose, clear
		* Check compatibility between values and #rows of file
		count
		if r(N)!=`nxval' {
			noi di in red "wrong number of observations" /*
			 */ "---expecting `nxval'"
			exit 198
		}
		gen `stub'=.
		cap drop _freq
		gen long _freq=.
		lab var _freq "Frequencies of `stub'"
		local i 1
		while `i'<=`nxval' {
			local v: word `i' of `values'
			replace `stub'=`v' in `i'
			local v: word `i' of `f'
			replace _freq=`v' in `i'
			local i=`i'+1
		}
	}
	else if `sumstat' {
		local i 1
		while `i'<=`nxval' {
			if "`mean'`sd'`n'"!="" {
				sum `stub'`i'
				if "`mean'"!="" {
					local m`i'=r(mean)
				}
				if "`sd'"!="" {	/* sqrt of MLE of variance */
					local s`i'=sqrt(r(Var)*(1-1/r(N)))
				}
			}
			if "`centile'"!="" {
				centile `stub'`i', cent(`centile')
				local nc=r(n_cent)
				local j 1
				while `j'<=`nc' {
					local c`i'`j'=r(c_`j')
					local j=`j'+1
				}
			}
			local i=`i'+1
		}
		* Save summary stats
		drop _all
		set obs `nxval'
		gen `stub'=.
		if "`mean'"!="" {
			gen _mean=.
			lab var _mean "Mean of `stub'"
		}
		if "`sd'"!="" {
			gen _sd=.
			lab var _sd "SD of `stub'"
		}
		if "`n'"!="" {
			gen long _freq=.
			lab var _freq "Frequencies of `stub'"
		}
		if "`centile'"!="" {
			local j 1
			while `j'<=`nc' {
				local cj: word `j' of `centile'
				gen _c`j'=.
				lab var _c`j' "`cj' centile of `stub'"
				local j=`j'+1
			}
		}
		local i 1
		while `i'<=`nxval' {
			local v: word `i' of `values'
			replace `stub'=`v' in `i'
			if "`mean'"!="" {
				replace _mean=`m`i'' in `i'
			}
			if "`sd'"!="" {
				replace _sd=`s`i'' in `i'
			}
			if "`n'"!="" {
				local v: word `i' of `f'
				replace _freq=`v' in `i'
			}
			if "`centile'"!="" {
				local j 1
				while `j'<=`nc' {
					replace _c`j'=`c`i'`j'' in `i'
					local j=`j'+1
				}
			}
			local i=`i'+1
		}
	}
	else if `stabil' {	/* code from pbxsum.ado */
		if "`mad'"!="" {
			cap drop _mad
			gen double _mad=0
		}
		if "`dsq'"!="" {
			cap drop _dsq
			gen double _dsq=0
		}
		tempname sumwt sumwt2 ntrunc n
		scalar `sumwt'=0
		local f: char _dta[pb_f]
		local i 1
		while `i'<=`nxval' {
			local fi: word `i' of `f'
			scalar `sumwt'=`sumwt'+`fi'
			local i=`i'+1
		}
		scalar `n'=`sumwt'
		scalar `ntrunc'=int(`n'*`trunc'+0.5) /* `ntrunc' could be 0 */
		scalar `sumwt'=0
		scalar `sumwt2'=0
		local i 1
		while `i'<=`nxval' {
			local fi: word `i' of `f'
			scalar `sumwt'=`sumwt'+`fi'
			if `sumwt'>`ntrunc' & `sumwt'<=(`n'-`ntrunc') {
				scalar `sumwt2'=`sumwt2'+`fi'
				replace `stub'`i'=abs(`stub'`i' /*
				 */ -`stub'`i'[`ref']) /*
				 */ if (_n!=`ref') & `touse'
				if "`mad'"!="" {
					replace _mad=_mad+`fi'*`stub'`i' /*
					 */ if `touse'&_n!=`ref'
				}
				if "`dsq'"!="" {
					replace _dsq=_dsq+`fi'*`stub'`i'^2 /*
					 */ if `touse'&_n!=`ref'
				}
			}
			else replace `stub'`i'=. if (_n!=`ref') & `touse'
			local i=`i'+1
		}
		if "`mad'"!="" {
			replace _mad=_mad/`sumwt2'
			lab var _mad "Mean absolute deviation for `stub' curve"
		}
		if "`dsq'"!="" {
			replace _dsq=_dsq/`sumwt2'
			lab var _dsq "Mean square deviation for `stub' curve"
		}
		if "`mad'"!="" { local keep _mad }
		if "`dsq'"!="" { local keep `keep' _dsq }
		keep `keep'
	}
}
restore, not
di _n in gr "Data now comprise " in ye `nxval' /*
 */ in gr " observations for " in ye "`stub'" in gr "."
ret local x `stub'
end
