!* v 1.0.1 PR 12nov2007
program define residual_plot_cmd, rclass
* Generate part of command for use in residual plots with ci.
* Creates a pale, outlined box defined by range i.e. [ll, ul] for y.
syntax varlist(min=4 max=4) [if] [in] , ///
 [ yl(string) yu(string) COLor(string) FINTensity(string) noZero noParen noRestrict ]

tokenize `varlist'
local y `1'
local cilow `2'
local cihigh `3'
local x `4'

if "`color'"=="" local color gs12

if "`fintensity'"=="" local fintensity inten10

* get 2.5 and 97.5 centiles of x, possibly for all values
if "`restrict'"=="norestrict" qui centile `x', centile(2.5 97.5)
else qui centile `x' `if' `in', centile(2.5 97.5)
local a = r(c_1)
local b = r(c_2)
* get range of y if not specified
if "`yl'"=="" {
	qui sum `cilow' `if' `in'
	local yl = r(min)
}
else confirm num `yl'
if "`yu'"=="" {
	qui sum `cihigh' `if' `in'
	local yu = r(max)
}
else confirm num `yu'
if "`zero'"!="nozero" {
	cap drop _zero
	qui gen _zero = 0 `if' `in'
	local zero _zero
	local zstuff clp(l -) lwidth(. thin)
}
else local zero
* To be precede by twoway
if "`paren'"=="noparen" {
	return local cmd1 function y=`yu', range(`a' `b') base(`yl') color(`color') fintensity(`fintensity') recast(area)
	return local cmd2 rarea `cilow' `cihigh' `x' `if' `in', sort pstyle(ci) legend(off)
	return local cmd3 line `y' `zero' `x' `if' `in', lstyle(refline) pstyle(p2) sort `zstuff'
}
else {
	return local cmd1 ( function y=`yu', range(`a' `b') base(`yl') color(`color') fintensity(`fintensity') recast(area) )
	return local cmd2 ( rarea `cilow' `cihigh' `x' `if' `in', sort pstyle(ci) legend(off) )
	return local cmd3 ( line `y' `zero' `x' `if' `in', lstyle(refline) pstyle(p2) sort `zstuff' )
}
return local cmd `return(cmd1)' `return(cmd2)' `return(cmd3)'
di _n as txt `"`return(cmd)'"'
end
