*! version 1.0.0 PR 24jul2004
* Updated 24jul2004 to allow program to split data into intervals. Also index option.
program define stfpt, rclass
version 8
st_is 2 full
if `"`_dta[st_id]'"' == "" {
	di as err /*
	*/ "sfpt requires that you have previously stset an id() variable"
	exit 198
}
/*
	Look for predictors and associated powers
*/
local pwrs
local tvc
local ntvc 0
local lastnv 0
parse "`*'", parse(" ,[")

gettoken next : 0, parse(" ,[")
while "`next'"!= ""  & "`next'"!="," & "`next'"!="if" & /*
*/    "`next'"!="in" & "`next'"!="[" { 
	gettoken next 0 : 0, parse(" ,[")	/* make real */
	cap unabbrev `next'
	if _rc == 0 { 		/* found a new xvarlist */
		local varl `s(varlist)'
		local nv `s(k)'
		if `ntvc'>0 {	/* have a previous xvarlist */
			*if "`pwrs'"=="" & `ntvc'>1 {
			if "`pwrs'"=="" {
				local pwrs 1
			}
			/*
				Flush powers
			*/
			local j=`ntvc'-`lastnv'+1
			while `j'<=`ntvc' {
				local p`j' `pwrs'
				local j=`j'+1
			}
			local pwrs
		}
		else {		/* this is first xvarlist */
			if `nv'>1 { 
				di as err /*
*/ "`next' ambiguous---xvar [#] required before covariate model is specified"
				exit 198
			}
		}
		/*
			Store current xvarlist names and 
			update variable count
		*/
		local j 1
		while `j'<=`nv' {
			local ntvc=`ntvc'+1
			local v`ntvc': word `j' of `varl'
			local tvc `tvc' `v`ntvc''
			local j=`j'+1
		}
		local lastnv `nv'
	}
	else {			/* got power(s) */
		if `ntvc'==0 {
			di as err /*
			*/ "invalid `next', not a varlist"
			exit 198
		}
		cap confirm num `next'
		if _rc { 
			di as err /*
*/ `""`next'" found where number or varlist expected"'
			exit 7
		}
		local pwrs `pwrs' `next'
	}
	gettoken next : 0, parse(" ,[")
}

if `ntvc'==0 {
	di as err "no xvar found"
	exit 198
}
/*
	Flush powers
*/
if "`pwrs'"=="" & `ntvc'>1 {
	local pwrs 1
}
local j=`ntvc'-`lastnv'+1
while `j'<=`ntvc' {
	local p`j' `pwrs'
	local j=`j'+1
}
* Allow either time option (if have created time periods) or interval option (to create time periods)
syntax [if] [in], [ FIXed(varlist) INTerval(real 1) MAXtime(real 0) MINtime(real 0) /*
 */ GENBt(string) GENIndex(string) noSCAling LABels(string) SE STRip TIME(varname) * ]
if "`time'"=="" {
	if `maxtime'<`interval' {
		di as err "invalid maxtime(), must exceed interval()"
		exit 198
	}
	if `mintime'<=0 {
		local mintime `interval'
	}
	local time _tm
	cap drop `time'
	cap drop _period
	stsplit _period, at(`mintime'(`interval')`maxtime')

	* Create means in each period
	qui egen `time'=mean(_t), by(_period)
}
* Initialise
forvalues i=1/`ntvc' {
	local tv`i': word `i' of `tvc'
	* `labels' are labels for output of tvc vars;
	* input names might be horrible (e.g. tempvars, I* vars)
	local lab: word `i' of `labels'
	if "`lab'"=="" {
		local lab`i' `tv`i''
	}
	else local lab`i' `lab'
}
quietly {
	marksample touse
	markout `touse' `tvc' `period'

	tempvar t1 t2
	gen double `t1'=.
	gen double `t2'=.
/*
	Process time-varying effects.
	
	Create FP transforms of time and products with covariates,
	and fit time-varying Cox model.
*/
	local tvarsin
	forvalues i=1/`ntvc' {
		local tv`i': word `i' of `tvc'
		fracgen `time' `p`i'' if `touse', replace name(`time') `scaling'
		local tfp `r(names)'
		local degree: word count `p`i''
		local vnew
		forvalues j=1/`degree' {
			local tfp`j': word `j' of `tfp'
			cap drop `tv`i''_t`j'
			gen double `tv`i''_t`j'=`tv`i''*`tfp`j''
			local vnew `vnew' `tv`i''_t`j'
		}
		local vnew`i' `vnew'
		local tvarsin `tvarsin' `vnew'
	}
	drop `tfp'
	noi stcox `fixed' `tvc' `tvarsin' if `touse', nohr `options'
	nobreak if "`genbt'"!="" {
		if "`tvarsin'"=="" {
			noi di as text "[no time-varying variables selected, nothing to predict]"
		}
		else {
			* Compute beta(t) for each time-varying xvar
			tempvar savetvar
			gen double `savetvar'=.
			forvalues i=1/`ntvc' {
				replace `savetvar'=`tv`i''
				replace `tv`i''=1
				fracgen `time' `p`i'' if `touse', replace name(`time') `scaling'
				local tfp `r(names)'
				local degsel: word count `p`i''
				forvalues j=1/`degsel' {
					local tfp`j': word `j' of `vnew`i''	/* product term j */
					local tt: word `j' of `tfp'		/* term j of FP of time */
					replace `t`j''=`tfp`j''
					replace `tfp`j''=`tt'
				}
				cap drop `genbt'`tv`i''
				_mfptxpredict `genbt'`tv`i'', with(`tv`i'' `vnew`i'')
				lab var `genbt'`tv`i'' "Beta(t) for `tv`i''"
				if "`se'"!="" {
					cap drop `genbt's`tv`i''
					_mfptxpredict `genbt's`tv`i'', with(`tv`i'' `vnew`i'') stdp
					lab var `genbt's`tv`i'' "SE(beta(t)) for `tv`i''"
				}
				replace `tv`i''=`savetvar'
				forvalues j=1/`degsel' {
					replace `tfp`j''=`t`j''
				}
				drop `tfp'
				if "`strip'"!="" {
					* remove redundant fitted values
					sort `time'
					by `time': replace `genbt'`tv`i''=. if _n>1
					if "`se'"!="" {
						by `time': replace `genbt's`tv`i''=. if _n>1
					}
				}
			}
		}
	}
}
end
