*! version 1.0.1 PR 29nov2004
program define stmfpt, rclass
* O'fach. as stmfpt but supports selection of default power (defpower),
* rather than assuming 1. Default default is 0 (log).
version 8
st_is 2 full
if `"`_dta[st_id]'"' == "" {
	di as err /*
	*/ "stmfpt2 requires that you have previously stset an id() variable"
	exit 198
}

* Disentangle
global MFpdist 7
_mfptGetVL `0'
local 0 `s(nought)'

syntax [if] [in], TIME(varname) [ DEFpower(string) DEGree(int 2) DETail FIXed(varlist) /*
 */ GENBt(string) LABels(string) noSCAling POWers(numlist) SE TVAlpha(real -1) TVSelect(real .05) * ]
if `degree'>2 {
	di as err "degree() must be 1 or 2"
	exit 198
}
if "`detail'"!="" {
	local detail noisily
}
if `tvalpha'<=0 {
	local tvalpha `tvselect'
}
if "`defpower'"=="" {
	local defpower 0	// log
}
if "`powers'"=="" {
	tokenize -2 -1 -0.5 0 0.5 1 2 3
}
else {
	tokenize `powers'
	local powers powers(`powers')
}
local i 1
while "``i''"!="" {
	local np `i'
	local p`i' ``i''
	local ++i
}

* Construct varlist and initialise
local ntvc $MFP_n
local tvc
local nclmax 0
forvalues i=1/`ntvc' {
	local tv`i' ${MFP_`i'}
	local ncl`i': word count `tv`i''
	local nclmax=max(`nclmax', `ncl`i'')
	local tvc `tvc' `tv`i''
	local in`i' 0
	* `labels' are labels for output of tvc vars;
	* input names might be horrible (e.g. tempvars, I* vars)
	local lab: word `i' of `labels'
	if "`lab'"=="" {
		local lab`i' `tv`i''
	}
	else local lab`i' `lab'
}

if "`tvc'"=="" {
	di as err "varlist required"
	exit 100
}
quietly {
	marksample touse
	markout `touse' `tvc' `time' `fixed'
	forvalues m=1/`nclmax' {
		tempvar t1`m' t2`m'
		gen double `t1`m''=.
		gen double `t2`m''=.
	}
/*
	Process time-varying effects.
	Find most significant FP`degree' function.
	Stop if not significant, else repeat.

	First fit non-time-varying Cox model with possible options and store deviance
*/
	tempname dev0 dev devfp1 devfp2 devdef ddfp2 ddfp1 dddef devnew pmin pval
	tempname pfp2null pfp2def pfp2fp1 pfp1null pfp1def
	tempname pfp2nullmin pfp2defmin pfp2fp1min pfp1nullmin pfp1defmin
	tempname devfp2min devfp1min devdefmin
	stcox `fixed' `tvc' if `touse', `options'
	scalar `dev0'=-2*e(ll)

	local dup0 41
	noi di as text _n "Note: Power for default (def) time-varying FP1 model is `defpower'"
	noi di as text _n "Variable   Powers     P-value    Final   "
	noi di as text    "name       selected   FP`degree' v null deviance"
	noi di as text "{hline `dup0'}"

	if "`detail'"!="" {
		noi di
		if `degree'==2 {
			local dup 77
			noi di as text "Variable       FP2pow  FP2dev  FP1pow  FP1dev  Defdev  P2_null P2_def  P2_FP1"
		}
		else {
			local dup 52
			noi di as text "Variable      FP1pow  FP1dev  Defdev  P1_null P1_def"
		}
		noi di in smcl as text "{hline `dup'}"
	}
	local tvarsin	/* time varying vars added to model */
	local done 0
	while !`done' {
		scalar `pmin'=1		/* P-value of most significant variable */
		local imin 0		/* index of most significant variable */
		forvalues i=1/`ntvc' {
			local tvar `tv`i''
			scalar `devfp1'=1e30
			scalar `devfp2'=1e30
			scalar `pval'=2		/* Initialised to be >pmin */
			local powfp1
			local powfp2
			if !`in`i'' {
				forvalues j=1/`np' {
					if `degree'==2 {
						forvalues k=`j'/`np' {
							fracgen `time' `p`j'' `p`k'' if `touse', replace name(`time') `scaling'
							local tfp1: word 1 of `r(names)'
							local tfp2: word 2 of `r(names)'
							local terms
							forvalues m=1/`ncl`i'' {
								local tm: word `m' of `tvar'
								replace `t1`m''=`tm'*`tfp1'
								replace `t2`m''=`tm'*`tfp2'
								local terms `terms' `t1`m'' `t2`m''
							}
							stcox `fixed' `tvc' `tvarsin' `terms' if `touse', `options'
							scalar `dev'=-2*e(ll)
							if `dev'<`devfp2' {
								scalar `devfp2'=`dev'
								local powfp2 `p`j'' `p`k''
							}
						}
					}
					else scalar `devfp2'=.
					if `degree'>=1 {
						fracgen `time' `p`j'' if `touse', replace name(`time') `scaling'
						local tfp1: word 1 of `r(names)'
						local terms
						forvalues m=1/`ncl`i'' {
							local tm: word `m' of `tvar'
							replace `t1`m''=`tm'*`tfp1'
							local terms `terms' `t1`m''
						}
						stcox `fixed' `tvc' `tvarsin' `terms' if `touse', `options'
						scalar `dev'=-2*e(ll)
						if `dev'<`devfp1' {
							scalar `devfp1'=`dev'
							local powfp1 `p`j''
						}
						if "`p`j''"=="`defpower'" {	// power for default FP1 model
							scalar `devdef'=`dev'
						}
					}
				}
				* Test significance via deviance differences
				scalar `ddfp1'=`dev0'-`devfp1'
				scalar `dddef'=`dev0'-`devdef'
				`detail' di as text %-12s "`lab`i''" _cont
				if `degree'==2 {
					scalar `ddfp2'=`dev0'-`devfp2'
					`detail' di as res %9s "`powfp2'" %8.3f `ddfp2' _cont
				}
				`detail' di as res %8s "`powfp1'" %8.3f `ddfp1' %8.3f `dddef' _cont
				* Test highest FP vs null and vs def
				if `degree'==2 {
					scalar `pfp2null'=chi2tail(4*`ncl`i'', `ddfp2')
					scalar `pfp2def'=chi2tail(3*`ncl`i'', `devdef'-`devfp2')
					scalar `pfp2fp1'=chi2tail(2*`ncl`i'', `devfp1'-`devfp2')
					scalar `pval'=`pfp2null'
					`detail' di as res %8.4f `pfp2null' %8.4f `pfp2def' %8.4f `pfp2fp1'
				}
				else if `degree'==1 {
					scalar `pfp1null'=chi2tail(2*`ncl`i'', `ddfp1')
					scalar `pfp1def'=chi2tail(1*`ncl`i'', `devdef'-`devfp1')
					scalar `pval'=`pfp1null'
					`detail' di as res %8.4f `pfp1null' %8.4f `pfp1def'
				}
			}
			if `pval'<`pmin' {
				scalar `pmin'=`pval'
				local imin `i'
				local powfp1min `powfp1'
				scalar `devfp1min'=`devfp1'
				scalar `devdefmin'=`devdef'
				if `degree'==2 {
					local powfp2min `powfp2'
					scalar `pfp2nullmin'=`pfp2null'
					scalar `pfp2defmin'=`pfp2def'
					scalar `pfp2fp1min'=`pfp2fp1'
					scalar `devfp2min'=`devfp2'
				}
				else {
					scalar `pfp1nullmin'=`pfp1null'
					scalar `pfp1defmin'=`pfp1def'
				}
			}
		}
		* Update list of significant TV vars and create necessary vars
		if `pmin'<`tvselect' {
			local in`imin' 1
			* Select model using RA2 algorithm
			if `degree'==2 {
				if `pfp2defmin'<`tvalpha' {	/* FP2 better than def */
					if `pfp2fp1min'<`tvalpha' {/* FP2 better than FP1 */
						local pwrs`imin' `powfp2min'
						scalar `devnew'=`devfp2min'
					}
					else {			/* Take FP1 */
						local pwrs`imin' `powfp1min'
						scalar `devnew'=`devfp1min'
					}
				}
				else {				/* Take default */
					local pwrs`imin' `defpower'
					scalar `devnew'=`devdefmin'
				}
			}
			else {					/* degree 1 */
				if `pfp1defmin'<`tvalpha' {	/* FP1 better than def */
					local pwrs`imin' `powfp1min'
					scalar `devnew'=`devfp1min'
				}
				else {				/* Take default */
					local pwrs`imin' `defpower'
					scalar `devnew'=`devdefmin'
				}
			}
			local degsel: word count `pwrs`imin''
			fracgen `time' `pwrs`imin'' if `touse', replace name(`time') `scaling'
			local vnew
			forvalues m=1/`ncl`imin'' {
				local tm: word `m' of `tv`imin''
				local stub `tm'_t
				forvalues j=1/`degsel' {
					local tfp`j': word `j' of `r(names)'
					cap drop `stub'`j'
					gen double `stub'`j'=`tm'*`tfp`j''
					lab var `stub'`j' "FP`degsel'(`tm')[`pwrs`imin'']"
					local vnew `vnew' `stub'`j'
				}
			}
			local vnew`imin' `vnew'	/* product(s) of FP of time with xvar(s), when xvar is timevarying */
			local tvarsin `tvarsin' `vnew'
			noi di as text %-12s substr("`lab`imin''",1,12) as res %-9s "`pwrs`imin''" %8.4f `pmin' %12.3f `devnew'
			scalar `dev0'=`devnew'
		}
		else local done 1
		cap drop `tfp1'
		cap drop `tfp2'
	}
	noi di as text "{hline `dup0'}" _n
	noi stcox `fixed' `tvc' `tvarsin' if `touse', nohr `options'
	if "`genbt'"!="" {
		if "`tvarsin'"=="" {
			noi di as text "[no time-varying variables selected, nothing to predict]"
		}
		else {
			* Compute beta(t) for each xvar selected as timevarying
			* First, fit final model (could be done noisily)
			tempvar savetvar
			gen double `savetvar'=.
			forvalues i=1/`ntvc' {
				nobreak if `in`i'' {
					fracgen `time' `pwrs`i'' if `touse', replace name(`time') `scaling'
					local tfp `r(names)'
					local degsel: word count `pwrs`i''
					local q 0
					forvalues m=1/`ncl`i'' {
						local tm: word `m' of `tv`i''
						replace `savetvar'=`tm'
						replace `tm'=1
						local vnew
						forvalues j=1/`degsel' {
							local ++q
							local tfp`j': word `q' of `vnew`i''	/* product term j */
							local tt: word `j' of `tfp'		/* term j of FP of time */
							local vnew `vnew' `tfp`j''
							replace `t`j'`m''=`tfp`j''
							replace `tfp`j''=`tt'
						}
						cap drop `genbt'`tm'
						_mfptxpredict `genbt'`tm', with(`tm' `vnew')
						lab var `genbt'`tm' "Beta(t) for `tm'"
						if "`se'"!="" {
							cap drop `genbt's`tm'
							_mfptxpredict `genbt's`tm', with(`tm' `vnew') stdp
							lab var `genbt's`tm' "SE(beta(t)) for `tm'"
						}
						replace `tm'=`savetvar'
						forvalues j=1/`degsel' {
							replace `tfp`j''=`t`j'`m''
						}
						* remove redundant fitted values
						sort `time'
						by `time': replace `genbt'`tm'=. if _n>1
						if "`se'"!="" {
							by `time': replace `genbt's`tm'=. if _n>1
						}
					}
					drop `tfp'
				}
			}
		}
	}
}
* Store powers and deviance
return scalar deviance=`dev0'
forvalues i=1/`ntvc' {
	return local fp_x`i' `lab`i''
	if "`pwrs`i''"=="" {
		return local fp_k`i' .
	}
	else {
		return local fp_k`i' `pwrs`i''
		return local fp_vn`i' `vnew`i''
	}
}
end

